"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.sampleNotFoundRoutesManifest = exports.sampleNotFoundRoutesRenderManifest = exports.sampleNotFoundRoutesPreRenderManifest = exports.sampleNotFoundRoutesBuildManifest = exports.sampleI18nManifest = exports.sampleRenderManifest = exports.sampleI18nPreRenderManifest = exports.sampleI18nBuildManifest = exports.sampleManifest = exports.samplePreRenderManifest = exports.sampleBuildManifest = void 0;
exports.sampleBuildManifest = {
    pages: {
        '/': [],
        '/[dynamic]': [],
        '/_app': [],
        '/_error': [],
    },
};
exports.samplePreRenderManifest = {
    routes: {
        '/page-0': {},
        '/page-1': {},
        '/page-2': {},
        '/page-3': {},
    },
    notFoundRoutes: [],
};
exports.sampleManifest = {
    build: exports.sampleBuildManifest,
    preRender: exports.samplePreRenderManifest,
};
exports.sampleI18nBuildManifest = {
    pages: {
        '/': [],
        '/about': [],
        '/[dynamic]': [],
        '/_app': [],
        '/_error': [],
    },
};
exports.sampleI18nPreRenderManifest = {
    routes: {
        '/en-US': {},
        '/fr': {},
        '/en-US/about': {},
        '/fr/about': {},
        '/page-0': {},
        '/page-1': {},
        '/en-US/page-1': {},
        '/page-2': {},
        '/fr/page-2': {},
        '/page-3': {},
    },
    notFoundRoutes: [],
};
exports.sampleRenderManifest = {
    i18n: {
        locales: ['en-US', 'fr', 'nl-NL', 'nl-BE'],
        defaultLocale: 'en-US',
    },
};
exports.sampleI18nManifest = {
    build: exports.sampleI18nBuildManifest,
    preRender: exports.sampleI18nPreRenderManifest,
    routes: exports.sampleRenderManifest,
};
exports.sampleNotFoundRoutesBuildManifest = {
    pages: {
        '/': [],
        '/about': [],
        '/only-nl': [],
        '/[dynamic]': [],
        '/_app': [],
        '/_error': [],
    },
};
exports.sampleNotFoundRoutesPreRenderManifest = {
    routes: {
        '/en-US': {},
        '/fr': {},
        '/nl-NL': {},
        '/en-US/about': {},
        '/fr/about': {},
        '/nl-NL/about': {},
        '/en-US/only-nl': {},
        '/fr/only-nl': {},
        '/nl-NL/only-nl': {},
        '/en-US/page-0': {},
        '/fr/page-0': {},
        '/nl-NL/page-0': {},
        '/en-US/page-1': {},
        '/fr/page-1': {},
        '/nl-NL/page-1': {},
    },
    notFoundRoutes: [
        '/fr',
        '/nl-NL/about',
        '/en-US/only-nl',
        '/fr/only-nl',
        '/nl-NL/page-0',
        '/fr/page-1',
        '/nl-NL/page-1',
    ],
};
exports.sampleNotFoundRoutesRenderManifest = {
    i18n: {
        locales: ['en-US', 'fr', 'nl-NL'],
        defaultLocale: 'en-US',
    },
};
exports.sampleNotFoundRoutesManifest = {
    build: exports.sampleNotFoundRoutesBuildManifest,
    preRender: exports.sampleNotFoundRoutesPreRenderManifest,
    routes: exports.sampleNotFoundRoutesRenderManifest,
};
