export const sampleBuildManifest = {
    pages: {
        '/': [],
        '/[dynamic]': [],
        '/_app': [],
        '/_error': [],
    },
};
export const samplePreRenderManifest = {
    routes: {
        '/page-0': {},
        '/page-1': {},
        '/page-2': {},
        '/page-3': {},
    },
    notFoundRoutes: [],
};
export const sampleManifest = {
    build: sampleBuildManifest,
    preRender: samplePreRenderManifest,
};
export const sampleI18nBuildManifest = {
    pages: {
        '/': [],
        '/about': [],
        '/[dynamic]': [],
        '/_app': [],
        '/_error': [],
    },
};
export const sampleI18nPreRenderManifest = {
    routes: {
        '/en-US': {},
        '/fr': {},
        '/en-US/about': {},
        '/fr/about': {},
        '/page-0': {},
        '/page-1': {},
        '/en-US/page-1': {},
        '/page-2': {},
        '/fr/page-2': {},
        '/page-3': {},
    },
    notFoundRoutes: [],
};
export const sampleRenderManifest = {
    i18n: {
        locales: ['en-US', 'fr', 'nl-NL', 'nl-BE'],
        defaultLocale: 'en-US',
    },
};
export const sampleI18nManifest = {
    build: sampleI18nBuildManifest,
    preRender: sampleI18nPreRenderManifest,
    routes: sampleRenderManifest,
};
export const sampleNotFoundRoutesBuildManifest = {
    pages: {
        '/': [],
        '/about': [],
        '/only-nl': [],
        '/[dynamic]': [],
        '/_app': [],
        '/_error': [],
    },
};
export const sampleNotFoundRoutesPreRenderManifest = {
    routes: {
        '/en-US': {},
        '/fr': {},
        '/nl-NL': {},
        '/en-US/about': {},
        '/fr/about': {},
        '/nl-NL/about': {},
        '/en-US/only-nl': {},
        '/fr/only-nl': {},
        '/nl-NL/only-nl': {},
        '/en-US/page-0': {},
        '/fr/page-0': {},
        '/nl-NL/page-0': {},
        '/en-US/page-1': {},
        '/fr/page-1': {},
        '/nl-NL/page-1': {},
    },
    notFoundRoutes: [
        '/fr',
        '/nl-NL/about',
        '/en-US/only-nl',
        '/fr/only-nl',
        '/nl-NL/page-0',
        '/fr/page-1',
        '/nl-NL/page-1',
    ],
};
export const sampleNotFoundRoutesRenderManifest = {
    i18n: {
        locales: ['en-US', 'fr', 'nl-NL'],
        defaultLocale: 'en-US',
    },
};
export const sampleNotFoundRoutesManifest = {
    build: sampleNotFoundRoutesBuildManifest,
    preRender: sampleNotFoundRoutesPreRenderManifest,
    routes: sampleNotFoundRoutesRenderManifest,
};
